<template>
  <v-container>
    <v-row justify="space-between">
      <v-col cols="12" md="5">
        <p class="page-title">
          Información de la compañía
        </p>
      </v-col>
    </v-row>
    <v-card outlined class="mx-auto" max-width="100%">
      <confirmation-modal :is-open="openModal" :modal-text="modalText" @confirm="confirmRegisterClient" @cancel="cancelRegister" />
      <v-card-subtitle class="pb-0">
        <image-field v-model="clientCompany.multipartFile" :disabled="disabledInformation" :url-image="clientCompany.profileImage" />
        <v-divider />
        <v-form ref="editEntityForm" class="mt-8" lazy-validation>
          <register-field-validation v-model="clientCompany.ruc" :disabled="true" field-name="RUC" :validation="rucRules" place-holder="Ingrese Ruc" @inputChange="changeRUC" />
          <register-field-validation v-model="clientCompany.name" :disabled="true" field-name="Razón Social" place-holder="Ingrese Razón Social" />
          <register-field-validation v-model="clientCompany.email" :disabled="disabledInformation" field-name="Correo Electrónico" :validation="emailRules" place-holder="Ingrese Correo" />
          <register-field-validation v-model="clientCompany.phone" :disabled="disabledInformation" field-name="Número de Teléfono" :validation="phoneRules" place-holder="Ingrese Teléfono" />
          <register-field-validation v-model="clientCompany.address" :disabled="disabledInformation" field-name="Dirección" :validation="addressRules" place-holder="Ingrese Dirección" />
        </v-form>
      </v-card-subtitle>
      <v-card-actions v-if="notEditable" class="d-flex justify-end">
        <v-btn
          depressed
          color="primary"
          style="padding: 15px"
          rounded
          outlined
          @click="allowEdition"
        >
          EDITAR
        </v-btn>
      </v-card-actions>

      <buttons-register-form
        v-else
        class="mt-4"
        @saveUser="handleRegisterClient"
        @cancel="handleCancelRegister"
      />

      <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
        {{ snackBar.text }}
        <template #action="{ attrs }">
          <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
            <v-icon>mdi-window-close</v-icon>
          </v-btn>
        </template>
      </v-snackbar>
    </v-card>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { rucRules, companyNameRules, emailRules, phoneRules, addressRules } from '~/helpers/validation';
import imageField from '~/components/InputField/ImageField';
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import ButtonsRegisterForm from '~/components/InputField/ButtonsRegisterForm.vue';
import ConfirmationModal from '~/components/register/confirmationModal';
import { imageDefault } from '~/helpers/constants';

export default {
  name: 'RegisterClients',
  components: { ButtonsRegisterForm, RegisterFieldValidation, imageField, ConfirmationModal },
  data() {
    return {
      openModal: false,
      modalText: '¿Estás seguro que deseas guardar los cambios?',
      notEditable: true,
      disabledInformation: true,
      disabledName: true,
      rucRules,
      companyNameRules,
      emailRules,
      phoneRules,
      addressRules,
      clientCompany: {
        address: '',
        name: '',
        phone: '',
        ruc: '',
        multipartFile: null,
        profileImage: null,
        companyEmail: '',
      },
      snackBar: {
        show: false,
        color: '',
        text: '',
      },
    };
  },
  computed: {
    ...mapState({
      checkedClientCompany: state => state.providercompany['client-company'].checkedClientCompany,
      supervisors: state => state['client-supervisor'].supervisors,
    }),
  },
  async mounted() {
    // await this.getAClientCompany();
    await this.getCompanyClient();
  },
  methods: {
    ...mapActions({
      updateClientCompany: 'clientcompany/client-company/updateClientCompany',
      checkedInformationClientCompany: 'providercompany/client-company/checkedInformationClientCompany',
      getClientSupervisors: 'client-supervisor/getClientSupervisor',
    }),
    async getCompanyClient() {
      await this.getClientSupervisors({ id: this.$route.params.id });
      this.clientCompany = JSON.parse(JSON.stringify(this.supervisors[0].clientCompany));
    },
    async changeRUC(valid) {
      if (valid) {
        const checkedClientCompany = await this.checkedInformationClientCompany(this.clientCompany.ruc);
        this.checkedCompany(checkedClientCompany.data);
      } else {
        this.disabled_user_info = true;
        this.disabled_specialist_info = true;
      }
    },
    checkedCompany(clientCompany) {
      this.snackBar.color = 'primary';
      this.clearForm();
      if (clientCompany.isRegistered) {
        this.snackBar.color = 'error';
        this.snackBar.text = 'Compañía cliente registrada con el RUC ingresado';
        this.disabledInformation = true;
        this.clientCompany = clientCompany.clientCompany;
      }
      this.snackBar.show = true;
    },
    allowEdition() {
      this.notEditable = false;
      this.disabledInformation = false;
    },
    handleRegisterClient() {
      if (this.$refs.editEntityForm.validate()) {
        this.openModal = true;
      }
    },
    async confirmRegisterClient() {
      await this.register();
      await this.getCompanyClient();
      this.notEditable = true;
      this.disabledInformation = true;
    },
    async register() {
      const formData = new FormData();
      if (this.clientCompany.multipartFile !== null) {
        if (this.clientCompany.multipartFile === undefined) {
          fetch(imageDefault)
            .then(function (response) {
              return response.blob();
            })
            .then(function (blob) {
              formData.append('multipartFile', blob);
            });
        } else {
          formData.append('multipartFile', this.clientCompany.multipartFile);
        }
      };
      formData.append('id', this.clientCompany.id);
      formData.append('name', this.clientCompany.name);
      formData.append('ruc', this.clientCompany.ruc);
      formData.append('email', this.clientCompany.email);
      formData.append('phone', this.clientCompany.phone);
      formData.append('address', this.clientCompany.address);
      console.log('va a llamar al update');
      await this.updateClientCompany({ clientCompany: formData });
      this.snackBar.text = 'Información actualizada correctamente';
      this.snackBar.color = 'primary';
      this.snackBar.show = true;
    },
    cancelRegister() {
      this.openModal = false;
    },
    async handleCancelRegister() {
      await this.getCompanyClient();
      this.notEditable = true;
      this.disabledInformation = true;
    },
    async clickButton() {
      if (this.$refs.editEntityForm.validate()) {
        // FIRST store information client comany in file store.
        const copia = Object.assign({}, this.clientCompany);
        await this.storeClientCompany(copia);
        // Then emit an event to go to step2.
        this.$emit('clickButton');
      }
    },
    clearForm() {
      this.clientCompany.name = '';
      this.clientCompany.address = '';
      this.clientCompany.phone = '';
    },
  },
};
</script>

<style scoped>
.page-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1.5rem;
  margin-top: 1rem;
  margin-left: 1rem;
}
.buttonRegisterLeft {
  margin-top: 1rem;
}
</style>
